/*## (c) SECURITY EXPLORATIONS    2012 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.util.*;
import java.io.*;
import java.security.*;

public class API {
 public static final int JVM_DIR_PAD = 60;
 public static PrintWriter out;

 private static String jcwd;

 public static void setOut(PrintWriter pw) {
  out=pw;
 }

 private static String padded_string(String s,int space) {
  int cnt=s.length();

  String pad="";

  if (cnt<space) {
   pad=s;

   for(int i=0;i<(space-cnt);i++) {
    pad+=" ";
   }
  } else pad=s.substring(s.length()-space);

  return pad;
 }

 private static void jvm_dir_internal(String dirname,boolean recurse,boolean fullpath) throws Throwable {
  int i;

  File dir=new File(dirname);

  out.println("["+dir.getAbsolutePath()+"]");

  File entries[]=dir.listFiles();

  if (entries==null) entries=new File[0];

  for(i=0;i<entries.length;i++) {
   String content="";

   File entry=entries[i];
  
   if (fullpath) {
    content+=padded_string(entry.getPath(),JVM_DIR_PAD);
   } else {
    content+=padded_string(entry.getName(),JVM_DIR_PAD);
   }

   if (entry.isDirectory()) {
    content+="<DIR>";
   } else {
    content+=entry.length();
   }

   out.println(content);
  }

  if (recurse) {
   out.println("");

   for(i=0;i<entries.length;i++) {
    File entry=entries[i];
    if (entry.isDirectory()) {
     jvm_dir_internal(entry.getPath(),recurse,fullpath);
    }
   }
  }
 }

 public static void jvm_dir(final String dirname) throws Throwable {
  AccessController.doPrivileged(new PrivilegedAction() {
    public Object run() {
     try {
      jvm_dir_internal(dirname,false,false);
     } catch(Throwable t) {}
     return null;
    }
  });

 }

 public static Object jvm_open(final String name) throws Throwable {
  Object filestream=AccessController.doPrivileged(new PrivilegedAction() {
    Object res=null;

    public Object run() {
     try {
      res=new FileInputStream(name);
     } catch(Throwable t) {}
     return res;
    }
  });

  return filestream;
 }

}
